/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.9.2.5 by edhill, Fri Oct 3 16:03:00 2003 UTC revision 1.131 by jmc, Sat Jan 2 01:53:49 2010 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env bash
2  #  #
3  #  $Header$  #  $Header$
4    #  $Name$
5  #  #
6    
7  usage()  usage()
# Line 10  usage() Line 11  usage()
11      echo      echo
12      echo "where possible OPTIONS are:"      echo "where possible OPTIONS are:"
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-mpi)                   use MPI input files"      echo "  (-mth)                   run multi-threaded (using eedata.mth)"
15      echo "  (-optfile=|-of=)STRING   list of optfiles to use"      echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-a|-addr)STRING         list of email recipients"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
17      echo "                             (DEF=\"edhill@mitgcm.org\")"      echo "                             (DEF=\"-ieee\")"
18      echo "  (-t|-tdir)STRING         list of test dirs to use"      echo "  (-gsl)                   compile with \"-gsl\" flag"
19      echo "                             (DEF=\"\" which builds all)"      echo "  (-of=|-optfile=)STRING   list of optfiles to use"
20      echo "  (-b|-bash)STRING         location of \"bash\" executable"      echo "  (-a|-addr) STRING        list of email recipients"
21      echo "                             (DEF=\"\" for \"/bin/bash\")"      echo "                             (DEF=\"\" no email is sent)"
22      echo "  (-c|-command)STRING      command to run"      echo "  (-mpd|-mpackdir) DIR     location of the mpack utility"
23        echo "                             (DEF=\"../tools/mpack-1.6\")"
24        echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"
25        echo "                             (recognized groups: basic, tutorials)"
26        echo "                             (DEF=\"\" which test all)"
27        echo "  (-skd|-skipdir) STRING   list of exp. dirs to skip"
28        echo "                             (DEF=\"\" which test all)"
29        echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"
30        echo "                             Bourne-compatible \"sh\" shell"
31        echo "                             (DEF=\"\" for \"bash\")"
32        echo "  (-adm|-ad)               perform an adjoint run"
33        echo "  (-oad)                   perform an OpenAD adjoint run"
34        echo "  (-command) STRING        command to run"
35      echo "                             (DEF=\"make output.txt\")"      echo "                             (DEF=\"make output.txt\")"
36      echo "  (-m|-make)STRING         command to use for \"make\""      echo "  (-m|-make) STRING        command to use for \"make\""
37      echo "                             (DEF=\"make\")"      echo "                             (DEF=\"make\")"
38        echo "  (-odir) STRING           used to build output directory name"
39        echo "                             (DEF=\"hostname\")"
40        echo "  (-ptr|-ptracers) STRING  specify which ptracers to test"
41        echo "                             (DEF=\"1 2 3 4 5\")"
42        echo "  (-match) NUMBER          Matching Criteria (number of digits)"
43        echo "                             (DEF=\"12\")"
44        echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
45        echo "  (-clean)                 *ONLY* run \"make CLEAN\""
46      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
47      echo "  (-nogenmake|-ng)         skip the genmake stage"      echo "  (-nogenmake|-ng)         skip the genmake stage"
48      echo "  (-noclean|-nc)           skip the \"make clean\" stage"      echo "  (-noclean|-nc)           skip the \"make clean\" stage"
49      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"
50        echo "  (-deldir|-dd)            on success, delete the output directory"
51        echo "  (-ts)                    provide timing information per timestep"
52        echo "  (-papis)                 provide MFlop/s per timestep using PAPI"
53        echo "  (-pcls)                  provide MFlop/s per timestep using PCL"
54      echo      echo
55      echo "and where STRING follows a whitespace-delimited format"      echo "and where STRING can be a whitespace-delimited list"
56      echo "such as:"      echo "such as:"
57        echo
58      echo "  -t 'exp0 exp2 exp3' "      echo "  -t 'exp0 exp2 exp3' "
59      echo "  -addr='abc@123.com testing@home.org'"      echo "  -addr='abc@123.com testing@home.org'"
60      echo      echo
61        echo "provided that the expression is properly quoted within the current"
62        echo "shell (note the use of single quotes to protect white space)."
63        echo
64      exit 1      exit 1
65  }  }
66    
67  #  build the mpack utility  #  build the mpack utility
68  build_mpack()  build_mpack()
69  {  {
70      echo -n "building the mpack utility...  "      printf "building the mpack utility...  "
71      if test ! -x "$MPACKDIR/mpack" ; then      MPACK="$MPACKDIR/mpack"
72        if test ! -x $MPACK ; then
73          if test ! -d $MPACKDIR ; then          if test ! -d $MPACKDIR ; then
74                echo
75              echo "Error: can't find \"$MPACKDIR\""              echo "Error: can't find \"$MPACKDIR\""
76              echo "  are you sure this program is being run in the correct "              echo "  are you sure this program is being run in the correct "
77              echo "  (that is, \"MITGCM_ROOT\verification\") directory?"              echo "  (that is, \"MITGCM_ROOT\verification\") directory?"
78              exit 1              echo
79                HAVE_MPACK=f
80          fi          fi
81          echo -n "building mpack...  "          if test "x$CC" = x ; then
82          ( cd $MPACKDIR && ./configure && $MAKE ) > build_mpack.out 2>&1              export CC=cc
83            fi
84            printf "building mpack (using CC=$CC)...  "
85            ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
86          RETVAL=$?          RETVAL=$?
87          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
88              echo              echo
89              echo "Error building the mpack tools at: $MPACK_DIR"              echo "Error building the mpack tools at: $MPACK_DIR"
90              exit 1              echo
91                HAVE_MPACK=f
92            else
93                rm -f tr_build_mpack.out
94                HAVE_MPACK=t
95                echo "done"
96          fi          fi
97        else
98            HAVE_MPACK=t
99            echo "already exist"
100      fi      fi
     echo "OK"  
 }  
   
 compare_lines()  
 {  
     # use codelet to compare lines  
     if [ $verbose -gt 1 ]; then  
         cat tmp3.txt 1>&2  
     fi  
     return `./a.out < tmp3.txt`  
101  }  }
102    
103  testoutput_for_prop()  testoutput_var()
104  {  {
105      # testoutput_for_prop dir s1 label subdir      # testoutput_var dir s1 label subdir reference_output
106      #      #
107      #  compares files in $dir/$subdir/output.txt and $dir/results/output.txt      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
108      #  using search strings s1 and text label      #     with same output from reference file $dir/results/$reference_output
109        #  using search strings s1 and text label
110    
111      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
112          echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2          echo testoutput_var: grep "$2" $1/$4/$OUTPUTFILE 1>&2
113      fi      fi
114      if [ -r $1/$4/output.txt ]; then      if [ -r $1/$4/$OUTPUTFILE ]; then
115          grep "$2" $1/$4/output.txt | sed 's/.*=//' | nl > tmp1.txt          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt
116          lncnt=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l tmp1.txt | awk '{print $1}' `
117          if [ $lncnt -lt 3 ]; then          if [ $lncntA -lt 2 ]; then
118              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
119                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
120              fi              fi
121              return 99              return 99
122          fi          fi
123      else      else
124          echo testoutput_for_prop: output.txt from model run was not readable 1>&2          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2
125          return 99          return 99
126      fi      fi
127      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
128          echo testoutput_for_prop: grep "$2" $1/results/output.txt 1>&2          echo testoutput_var: grep "$2" $1/results/$5 1>&2
129      fi      fi
130      grep "$2" $1/results/output.txt | sed 's/.*=//' | nl > tmp2.txt      grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt
131      lncnt=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
132      if [ $lncnt -lt 3 ]; then      if [ $lncntB -lt 2 ]; then
133          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
134              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
135          fi          fi
136          return 99          return 99
137      fi      fi
138        if [ $lncntA -ne $lncntB ]; then
139            if [ $verbose -gt 0 ]; then
140                echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2
141            fi
142            return 99
143        fi
144        has_nan=`cat tmp1.txt | grep -i nan | wc -l`
145        if [ $has_nan -gt 0  ] ; then
146            echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2
147            return 99
148        fi
149        has_inf=`cat tmp1.txt | grep -i inf | wc -l`
150        if [ $has_inf -gt 0  ] ; then
151            echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2
152            return 99
153        fi
154      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
155          echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2          echo testoutput_var: join tmp1.txt tmp2.txt 1>&2
156      fi      fi
157      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt
158      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
159          echo testoutput_for_prop: compare_lines 1>&2          echo testoutput_var: compare_lines 1>&2
160        fi
161        if [ $verbose -gt 1 ]; then
162            cat tmp3.txt 1>&2
163      fi      fi
164      compare_lines      echo "-1" >> tmp3.txt
165      digits_of_similarity=$?      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
166        cat tmp3.txt | sed -e 's|:||g' > tmp4.txt
167        digits_of_similarity=`./tr_cmpnum < tmp4.txt`
168      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
169          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
170              echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2              echo testoutput_var: No comparison was available for \"$3\" 1>&2
171          fi          fi
172          digits_of_similarity=99          digits_of_similarity=99
173      else      else
174          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
175              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2
176          fi          fi
177      fi      fi
178      rm tmp1.txt tmp2.txt tmp3.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
179            
180      return $digits_of_similarity      return $digits_of_similarity
181  }  }
182    
183  dashnum()  testoutput_run()
184  {  {
185      # dashnum n1 n2 n3 ...      # testoutput_run directory subdir reference_output
186      #      #
187      #  print numbers using %3i format or "--" if number = 99      #  test output from 1 run in "directory"
188    # --> same processing for adjoint & forward test
189      for num in $@ ; do          # default list of output variables to be checked:
190          if [ $num = 99 ]; then          #  1rst : main variable used to decide if it pass or FAIL
191              printf ' --'          #  others : number of matching digits to be printed in summary.txt
192          else          listChk=$DEF_CHECK_LIST
193              printf '%3i' $num          #  load experiment-specific list from file "tr_checklist" (if it exist)
194          fi          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
195      done          sVar=`echo $listChk | awk '{print $1}'`
196  }          # remove 1rst var and expand the list: + => min max mean s.d
197            listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
198  testoutput()                                 | sed 's/+//g' | sed "s/^$sVar//"`
199  {          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
200      # testoutput diretory subdir          # check for ptracer output in reference_output file :
201      #          outpref=$1/results/$3
202      #  test output in "directory"          ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"
203            ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"
204      if [ $debug -gt 0 ]; then          for ii in $PTRACERS_NUM ; do
205          echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2              ptrfound=0
206      fi              for jj in $ptr_mon ; do
207      testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2; cg2dres=$?                  name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`
208      if [ $debug -gt 0 ]; then                  tst=`grep $name $outpref | wc -l | awk '{print $1}'`
209          echo testoutput: cg2dres=$cg2dres 1>&2                  if test ! "x$tst" = x0 ; then ptrfound=1 ; fi
210      fi              done
211                    if test $ptrfound = '1' ; then
212      testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2; tmin=$?                  eval "HAVE_PTR0"$ii"=t"
213      testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2; tmax=$?              else
214      testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2; tmean=$?                  eval "HAVE_PTR0"$ii"=f"
215      testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2; tsd=$?                if test "x$ADM" = x -a "x$OADM" = x; then
216      testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2; smin=$?                # remove this ptr from the list of output variable to check
217      testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2; smax=$?                # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
218      testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2; smean=$?                  listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`
219      testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2; ssd=$?                fi
220      testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2; umin=$?              fi
221      testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2; umax=$?          #   eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2
222      testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2; umean=$?          done
223      testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2; usd=$?          tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`
224      testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2; vmin=$?          if test $tst != 1 ; then
225      testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2; vmax=$?            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
226      testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2; vmean=$?                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
227      testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2; vsd=$?            echo "==> WARNING: in checked list:" $listVar 1>&2
228                #- put it back once:
229      dashnum $cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd \            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`
230          $umin $umax $umean $usd $vmin $vmax $vmean $vsd          fi
231            if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi
232            echo "listVar='$listVar'" > $CDIR"/summary.txt"
233            allargs=""
234            for xx in $listVar
235            do
236              case $xx in
237               'PS')  if [ $debug -gt 0 ]
238                      then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
239                      testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?
240                      if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
241              'Cost') testoutput_var $1 "ADM  precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;
242              'Grad') testoutput_var $1 "ADM  precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;
243               'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $3; yy=$? ;;
244               'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $3; yy=$? ;;
245               'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $3; yy=$? ;;
246               'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $3; yy=$? ;;
247               'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $3; yy=$? ;;
248               'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $3; yy=$? ;;
249               'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $3; yy=$? ;;
250               'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $3; yy=$? ;;
251               'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;
252               'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;
253               'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;
254               'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $3; yy=$? ;;
255               'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;
256               'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;
257               'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;
258               'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $3; yy=$? ;;
259            'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
260               testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;
261            'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
262               testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $3; yy=$? ;;
263            'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
264               testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
265            'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
266               testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;
267             'Qntmn') testoutput_var $1 "forcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;
268             'Qntmx') testoutput_var $1 "forcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;
269             'Qntav') testoutput_var $1 "forcing_qnet_mean" "Qnet mean"       $2 $3; yy=$? ;;
270             'Qntsd') testoutput_var $1 "forcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;
271             'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;
272             'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;
273             'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;
274             'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;
275             'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;
276             'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Heff max"   $2 $3; yy=$? ;;
277             'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Heff mean"  $2 $3; yy=$? ;;
278             'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Heff StDv"  $2 $3; yy=$? ;;
279            'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;
280            'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;
281            'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;
282            'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global"    $2 $3; yy=$? ;;
283            'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South"     $2 $3; yy=$? ;;
284            'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North"     $2 $3; yy=$? ;;
285                  *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
286              esac
287              if test $xx = $sVar
288              then allargs="$allargs > $yy <"
289              else allargs="$allargs $yy"
290              fi
291            done
292    
293            nbVar=`echo $listVar | awk '{print NF}'`
294            if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
295            #-- fill line (up to standard length) with dot:
296              adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
297              echo $allargs $adNul
298            else
299              echo $allargs
300            fi
301    # <-- same processing for adjoint & forward test
302  }  }
303    
304  genmakemodel()  genmakemodel()
# Line 181  genmakemodel() Line 307  genmakemodel()
307      if test "x$NOGENMAKE" = xt ; then      if test "x$NOGENMAKE" = xt ; then
308          echo "genmake skipped!"          echo "genmake skipped!"
309      else      else
310          GENMAKE2="$BASH ../../../tools/genmake2"          if test "x$BASH" = x ; then
311                GENMAKE2="../../../tools/genmake2"
312            else
313                GENMAKE2="$BASH ../../../tools/genmake2 -bash $BASH"
314            fi
315          (          (
316              cd $1;              cd $1;
317                command="$GENMAKE2  -ds -m $MAKE"
318                if test "x$ADM" = xt ; then
319                    command="$command --mods=../code_ad"
320                elif test "x$OADM" = xt ; then
321                    command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods '../code_oad ../../OpenAD/code_oad_all'"
322                else
323                    command="$command -mods=../code"
324                fi
325                if test "x$OPTFILE" != xNONE ; then
326                    command="$command -optfile=$OPTFILE"
327                fi
328                if test "x$IEEE" != x ; then
329                    command="$command -ieee"
330                fi
331                if test "x$GSL" = xt ; then
332                    command="$command -gsl"
333                fi
334                if test "x$MPI" = xt ; then
335                    command="$command -mpi"
336                fi
337                if test "x$MULTI_THREAD" = xt ; then
338                #- run multi-threaded using OpenMP:
339                    command="$command -omp"
340                fi
341                if test "x$TS" = xt ; then
342                    command="$command -ts"
343                fi
344                if test "x$PAPIS" = xt ; then
345                    command="$command -papis"
346                else
347                if test "x$PCLS" = xt ; then
348                    command="$command -pcls"
349                fi
350                fi
351              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
352              # ../../../tools/genmake -ieee -mods=../code > make.log 2>&1              # $command > make.log 2>&1
353              $GENMAKE2  -ds -m $MAKE --mods=../code "--optfile="$OPTFILE > make.log 2>&1              eval $command > make.log 2>&1
354              RETVAL=$?              RETVAL=$?
355              for i in gm_state gm_optfile gm_local Makefile ; do              #  Reduce the size of the testing emails!
356                  if test -r $i ; then              head -100 Makefile > $CDIR/Makefile_head
                     cp $i $CDIR  
                 fi  
             done  
357              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
358                  tail make.log                  tail make.log
359                  echo "genmakemodel: genmake failed" 1>&2                  echo "genmakemodel: genmake failed" 1>&2
360                  cp make.log $CDIR                  cp genmake_* make.log $CDIR
361                  return 1                  return 1
362              else              else
363                  echo "succesful" 1>&2                  echo "successful" 1>&2
364              fi              fi
365          )          )
366      fi      fi
# Line 209  makeclean() Line 370  makeclean()
370  {  {
371      # makeclean directory      # makeclean directory
372      if test "x$NOCLEAN" = xt ; then      if test "x$NOCLEAN" = xt ; then
373          echo "make CLEAN skipped!"          echo "make Clean skipped!"
374      else      else
375          (          (
376              cd $1;              cd $1;
377              if test -e output.txt ; then              #if test -e $OUTPUTFILE ; then rm -f $OUTPUTFILE ; fi
                 rm -f output.txt  
             fi  
             printf 'make CLEAN ... ' 2>&1  
378              if test -r Makefile ; then              if test -r Makefile ; then
379                  $MAKE CLEAN >> make.log 2>&1                  printf 'clean build-dir: make Clean ... ' 2>&1
380                    $MAKE Clean >> make.log 2>&1
381                  RETVAL=$?                  RETVAL=$?
382                  if test "x$RETVAL" != x0 ; then                  if test "x$RETVAL" != x0 ; then
383                      tail make.log                      tail make.log
384                      echo "makeclean: \"make CLEAN\" failed" 1>&2                      echo "makeclean: \"make Clean\" failed" 1>&2
385                      cp make.log $CDIR"/make.log"                      cp make.log $CDIR"/make.log"
386                      return 1                      return 1
387                  fi                  fi
388                    echo successful 1>&2
389                else
390                    echo ''
391              fi              fi
392              echo succesful 1>&2              exit 0
393            )
394        fi
395    }
396    
397    run_clean()
398    {
399        # run_clean directory
400        if test "x$NOCLEAN" = xt ; then
401            echo "run_clean skipped!"
402        else
403            (
404                cd $1;
405                printf 'clean run-dir ... ' 2>&1
406                # part of what is done after "make clean" when doing "make CLEAN"
407                find . -name "*.meta" -exec rm {} \;
408                find . -name "*.data" -exec rm {} \;
409                find . -name "fort.*" -exec rm {} \;
410                find . -type l -exec rm {} \;
411                rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime
412                rm -rf mnc_test_*
413                rm -f *_MIT_CE_000.opt0000 costfunction*0000
414                echo successful 1>&2
415              exit 0              exit 0
416          )          )
417      fi      fi
# Line 250  makedependmodel() Line 434  makedependmodel()
434                  cp make.log $CDIR"/make.log"                  cp make.log $CDIR"/make.log"
435                  return 1                  return 1
436              else              else
437                  echo succesful 1>&2                  echo successful 1>&2
438              fi              fi
439          )          )
440      fi      fi
# Line 263  makemodel() Line 447  makemodel()
447          cd $1;          cd $1;
448          if test -r Makefile ; then          if test -r Makefile ; then
449              printf 'make ... ' 1>&2              printf 'make ... ' 1>&2
450              $MAKE >> make.log 2>&1              if test "x$ADM" = xt ; then
451                    $MAKE adall >> make.log 2>&1
452                elif test "x$OADM" = xt ; then
453                    $MAKE adAll >> make.log 2>&1
454                else
455                    if test "x$JOBS" = x ; then
456                        $MAKE >> make.log 2>&1
457                    else
458                        $MAKE -j $JOBS >> make.log 2>&1
459                    fi
460                fi
461              RETVAL=$?              RETVAL=$?
462              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
463                  tail make.log                  tail make.log
464                  echo failed 1>&2                  echo failed 1>&2
465                  cp make.log $CDIR"/make.log"                  cp make.log $CDIR"/make.log"
466                    rm -f $EXECUTABLE
467                  return 1                  return 1
468              else              else
469                  echo succesful 1>&2                  echo successful 1>&2
470              fi              fi
471          fi          fi
472      )      )
473  }  }
474    
475    symlink_mpifiles()
476    {
477        # Put special links so that MPI specific files are used
478        # This MUST be invoked between makeclean and makelinks because
479        # the Makefile will link to non-mpi files by default
480    
481        dir=$1
482        code_dir=$2
483        BUILD_DIR=$dir/$3
484        CODE_DIR=$dir/$code_dir
485        
486        # These are files that should replace their counter-part when using -mpi
487        MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
488    
489        #  Is this an MPI run?
490        if test "x$MPI" = xt ; then
491            # YES: We symbolically link these files to the build
492            # dir so long as there is no real file in place
493            for ii in $MPI_FILES ; do
494                i=`echo $ii | sed 's:^\./::'`
495                name=`echo $i | sed 's:_mpi::' `
496                cmp $CODE_DIR/$i $BUILD_DIR/$name > /dev/null 2>&1
497                RETVAL=$?
498                if test "x$RETVAL" != x0 ; then
499                    if ! test -f $BUILD_DIR/$i ; then
500                        #echo Linking $name to $i
501                        (cd $BUILD_DIR; ln -sf ../$code_dir/$i $name)
502                    fi
503                fi
504            done
505        else
506            # NO: We undo any _mpi symbolically linked files
507            for ii in $MPI_FILES ; do
508                i=`echo $ii | sed 's:^\./::'`
509                name=`echo $i | sed 's:_mpi::' `
510                if test -L $BUILD_DIR/$name ; then
511                    cmp $BUILD_DIR/$name "../$code_dir/$name"_mpi > /dev/null 2>&1
512                    RETVAL=$?
513                    if test "x$RETVAL" = x0 ; then
514                        #echo Un-linking $name from $linktarg
515                        rm -f $BUILD_DIR/$name
516                    fi
517                fi
518            done
519        fi
520        
521    }
522    
523  linkdata()  linkdata()
524  {  {
525      # linkdata flag      # linkdata run_dir input_dir_1 input_dir_2 ...
526      #      #
527      # symbolically link data files to run directory      # symbolically link data files to run directory
528      if [ $1 -ne 0 ]; then      if test -d $1 ; then
529          ( cd $2 ;  ln -sf ../input/* . )          (
530                cd $1 ; shift
531                inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`
532                for xx in $inpMPI ; do
533                  if test -r "../"$1"/"$xx ; then
534                    # found 1 _mpi sfx file in 1rst input dir and it is readable
535                    yy=`echo $xx | sed 's:\.mpi$::'`
536                    if test "x$MPI" = "xt" ; then
537                    # mpi test: remove symbolic link & link _mpi sfx file
538                        if test -h $yy ; then rm -f $yy ; fi
539                        if test ! -r $yy ; then
540                            ln -sf "../"$1"/"$xx $yy ;
541                            printf "$xx " 1>&2
542                        fi
543                    else
544                    # not mpi test: remove symbolic link
545                        if test -h $yy ; then rm -f $yy ; fi
546                    fi
547                  fi
548                done
549                if test -r "../"$1"/eedata.mth" ; then
550                # found eedata.mth in 1rst input dir and it is readable
551                    if test "x$MULTI_THREAD" = "xt" ; then
552                    # multi-threaded test: remove symbolic link & link eedata.mth
553                        if test -h eedata ; then rm -f eedata ; fi
554                        if test ! -r eedata ; then
555                            ln -sf "../"$1"/eedata.mth" eedata ;
556                            printf 'eedata.mth ' 1>&2
557                        fi
558                    else
559                    # not multi-threaded test: remove eedata symbolic link
560                        if test -h eedata ; then rm -f eedata ; fi
561                    fi
562                fi
563                prevDir='NONE'
564                for ldir in $* ; do
565                    if test -d "../"$ldir -a $ldir != $prevDir ; then
566                        printf 'ldir='${ldir} 1>&2
567                        files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
568                        for i in $files ; do
569                            if test ! -d "../"$ldir/$i ; then
570                                if test ! -r $i  ; then
571                                    printf ' '$i 1>&2
572                                    ln -sf "../"$ldir"/"$i $i
573                                fi
574                            fi
575                        done
576                        if test -x "../"$ldir"/"prepare_run ; then
577                            "../"$ldir"/"prepare_run
578                        fi
579                        printf ' ; ' 1>&2
580                    fi
581                    prevDir=$ldir
582                done
583            )
584      fi      fi
585  }  }
586    
# Line 291  runmodel() Line 588  runmodel()
588  {  {
589      # runmodel directory      # runmodel directory
590      #      #
591      #  runs "$COMMAND" in "directory"      #  runs "$COMMAND in "directory"
592      #  (where "$COMMAND" is relative to "directory")      #  (where "$COMMAND" is relative to "directory")
593      (      (
594          cd $1          cd $1
595          printf 'runmodel: ' 1>&2          printf 'runmodel in %s ...' $1 1>&2
596          # make output.txt          # make output.txt
597          $COMMAND          echo
598          RETVAL=$?          if test -L $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
599          if test "x$RETVAL" = x0 ; then              diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
600              cp output.txt $CDIR"/output.txt"              outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; fi
601            fi
602            if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
603                echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp
604                ln -sf "../"$builddir"/"$EXECUTABLE .
605            fi
606            if test ! -x $EXECUTABLE ; then
607                    rm -f $RUNLOG ; touch $RUNLOG
608                    if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
609                    echo " no executable:" $EXECUTABLE >> $RUNLOG
610                    RETVAL=8
611                    ENDVAL=-1
612            else
613                if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
614                  # output do not exist or is older than executable:
615                    rm -f $RUNLOG ; touch $RUNLOG
616                    if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
617                    ( eval $COMMAND ) >> $RUNLOG 2>&1
618                    RETVAL=$?
619                else
620                    RETVAL=0
621                    if test -f $RUNLOG ; then
622                        if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
623                        echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
624                    else
625                        touch $RUNLOG
626                        if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
627                        echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
628                        echo " no previous $RUNLOG: assume NORMAL END" >> $RUNLOG 2>&1
629                    fi
630                fi
631                ENDVAL=`cat $RUNLOG | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`
632            fi
633            rm -f run.log_tmp
634            #if test "x$RETVAL" = x0 ; then
635            if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
636                tail $RUNLOG
637                echo successful 1>&2
638                # === Reduce the size of the testing emails!
639                #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE
640                if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
641              return 0              return 0
642          else          else
643                tail $RUNLOG
644                echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
645                cp $RUNLOG $CDIR"/"$RUNLOG
646                if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
647              return 1              return 1
648          fi          fi
649      )      )
# Line 312  createcodelet() Line 653  createcodelet()
653  {  {
654      # create codelet for comparing model output      # create codelet for comparing model output
655    
656      echo -n "creating the comparison code...  "      printf "creating the comparison code (using CC=$CC)...  "
657      cat > tmp_cmpnum.f <<EOFA      cat > tr_cmpnum.c <<EOF
658        program cmpnum  #include <stdio.h>
659        implicit none  #include <math.h>
660        real*8 a,b,diff  int main( int argc, char** argv )  {
661        integer linnum,best    int linnum,cmplin,best,lncnt;
662        best=-16    double a,b,abave,relerr;
663    99  read(*,*,end=70,err=60) linnum,a,b    best = -22;
664        diff=0.5*(abs(a)+abs(b))    lncnt = 0;
665  c     print *,a,b,diff,abs(a-b)/diff    while( 1 & ( (lncnt+=1) < 999 ) )  {
666        if (diff.gt.1.e-12) then      scanf("%d", &linnum);
667          diff=abs(a-b)/diff      if (linnum == -1)  break;
668          if (diff.gt.0.) then      scanf("%lf", &a);  scanf("%lf", &b);
669  c         print *,int(log10(diff)),diff      abave = 0.5*(fabs(a)+fabs(b));
670            linnum=int(log10(diff))      if ( abave == abave ) {
671            best=max(best,linnum)        if (abave > 0.0) {
672          endif          relerr=fabs(a-b)/abave;
673        else          if (relerr > 0.0) { cmplin = (int)rint(log10(relerr)); }
674          if (best.eq.-16.and.diff.ne.0.) best=-22          else { cmplin = -16 ; }
675        endif          best = (best > cmplin) ? best : cmplin; }
676        goto 99        else { cmplin = -22 ; }
677    60  stop 'cmpnum: An error occured reading a,b'     /* printf("%d ; %lf ; %lf\n",cmplin,a,b); */
678    70  print *,-best        }
679        end     else {
680  EOFA     /* printf("%lf ; %lf ; %lf\n",abave,a,b); */
681          break; }
682      }
683      if (lncnt == 999) best=-29;
684      if (linnum != -1) best=-99;
685      printf("%d\n", -best);
686      return 0;
687    }
688    EOF
689        $CC -o tr_cmpnum tr_cmpnum.c -lm
690    
691      f77 tmp_cmpnum.f      if [ -x ./tr_cmpnum ]; then
     if [ -x ./a.out ]; then  
692          echo "OK"          echo "OK"
693          return 0          return 0
694      else      else
695          echo          echo
696          echo "createcodelet: failed to compile codelet"          echo "ERROR: failed to compile comparison code -- please specify"
697            echo "  a C compiler using the CC environment variable."
698          exit 1          exit 1
699      fi      fi
700  }  }
# Line 356  formatresults() Line 706  formatresults()
706      nm=$1      nm=$1
707      printf '%s %s %s %s' $2 $3 $4 $5      printf '%s %s %s %s' $2 $3 $4 $5
708      shift; shift; shift; shift; shift;      shift; shift; shift; shift; shift;
709      printf '%3s' $@      listPrt=$@
710        listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`
711        xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`
712        printf '%3s' $listPrt
713    #   line below does not work on hp-ux_ia64 : do those substitutions later on
714    #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'
715            
716      if [ $1 = '--' ]; then      if [ $xx = '..' ]; then
717            printf ' N/O '
718        elif [ $xx = '--' ]; then
719            printf ' N/O '
720        elif [ $xx = 99 ]; then
721          printf ' N/O '          printf ' N/O '
722      else      else
723          if [ $1 -gt 12 ]; then          if [ $xx -ge $MATCH_CRIT ]; then
724              printf ' pass'              printf ' pass'
725          else          else
726              printf ' FAIL'              printf ' FAIL'
# Line 372  formatresults() Line 731  formatresults()
731            
732  }  }
733    
734  show_help()  scandirs()
735  {  {
736      cat - << EOF      if [ $# -eq 1 ]; then
737  $0 [-help] [-quick] [-verbose] dir1 [dir2] [...]          for arg in * ; do
738                test -f $arg/$1 && echo $arg
739   -help|-h      Show this help message          done
740   -quiet     Reduce the amount of output      else
741   -verbose   Produce copious amounts of output          echo $*
742   -debug     Produce even more output which will mean nothing to most      fi
  -force     Do "make CLEAN" before compiling. This forces a complete rebuild.  
  -clean     Do "make CLEAN" after compiling and testing.  
  -noieee    By default, $0 uses the -ieee option for genmake. This turns it off.  
  -cleanup   Aggresively removes all model output, executables and object files  
             and then exits. Use with care.  
   
 Normal usage:  
  $0 *       Configure, compile, run and analyze in all experiment directories  
 EOF  
743  }  }
744    
745  scandirs()  
746    check_eedata()
747  {  {
748      if [ $# -eq 0 ]; then      # check_eedata size.h eedata
749          for arg in * ; do      if [ $# -eq 2 ] ; then
750              test -d $arg/input && echo $arg        if test -f $1 -a -f $2 ; then
751          done        sx=`grep "^     & *nSx *=" $1 | sed "s/^     & *nSx *=//" | sed 's/, *$//'`
752          nx=`grep "^ *nTx *=" $2 | tail -1 | sed 's/^ *nTx *= *//' | sed "s/, *$//"`
753          if test "x$nx" = x ; then
754            rx=10
755          else
756            rx=`expr $sx % $nx`
757          fi
758          sy=`grep "^     & *nSy *=" $1 | sed "s/^     & *nSy *=//" | sed 's/, *$//'`
759          ny=`grep "^ *nTy *=" $2 | tail -1 | sed 's/^ *nTy *= *//' | sed "s/, *$//"`
760          if test "x$ny" = x ; then
761            ry=20
762          else
763            ry=`expr $sy % $ny`
764          fi
765          echo `expr $rx + $ry`
766      else      else
767          echo $*        echo '-1'
768          fi
769        else
770          echo '-2'
771      fi      fi
 }  
772    
773    }
774    
775  ###############################################################################  ###############################################################################
 ###############################################################################  
 ###############################################################################  
776    
777    
778  #  Default properties  #  Default properties
779  debug=0  debug=0
780  verbose=1  verbose=1
781  clean=0  clean=0
782  expts=''  
783  # ieee=1  IEEE=true
784    if test "x$MITGCM_IEEE" != x ; then
785        IEEE=$MITGCM_IEEE
786    fi
787    GSL=f
788    
789  CLEANUP=f  CLEANUP=f
790  QUICK=f  QUICK=f
791  NOGENMAKE=f  NOGENMAKE=f
792  NOCLEAN=f  NOCLEAN=f
793  NODEPEND=f  NODEPEND=f
794    POSTCLEAN=f
795    
796  BASH=  BASH=
797  OPTFILES=  OPTFILE=NONE
798  ADDRESSES=  ADDRESSES=
799  TESTDIRS=  TESTDIRS=
800    SKIPDIRS=
801  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
802  MPACK="$MPACKDIR/mpack"  HAVE_MPACK=
803  COMMAND="make output.txt"  MPACK=
804  MAKE=make  COMMAND=
805    if test "x$MAKE" = x ; then
806        MAKE=make
807    fi
808    if test "x$CC" = x ; then
809        CC=cc
810    fi
811    JOBS=
812  MPI=f  MPI=f
813    MULTI_THREAD=f
814    OUTDIR=
815    DELDIR=
816    
817    ADM=
818    OADM=
819    
820    # list of pTracers to check for monitor output
821    PTRACERS_NUM="1 2 3 4 5"
822    
823  echo -n "parsing options...  "  MATCH_CRIT=13
824    
825    printf "parsing options...  "
826    
827  ac_prev=  ac_prev=
828  for ac_option ; do  for ac_option ; do
# Line 452  for ac_option ; do Line 842  for ac_option ; do
842              usage ;;              usage ;;
843                    
844          -optfile | --optfile | -of | --of)          -optfile | --optfile | -of | --of)
845              ac_prev=OPTFILES ;;              ac_prev=OPTFILE ;;
846          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
847              OPTFILES=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
848                    
849          -addr | --addr | -a | --a)          -addr | --addr | -a | --a)
850              ac_prev=ADDRESSES ;;              ac_prev=ADDRESSES ;;
851          -addr=* | --addr=*)          -addr=* | --addr=*)
852              ADDRESSES=$ac_optarg ;;              ADDRESSES=$ac_optarg ;;
853            -mpackdir | --mpackdir | -mpd | --mpd)
854                ac_prev=MPACKDIR ;;
855            -mpackdir=* | --mpackdir=* | -mpd=* | --mpd=*)
856                MPACKDIR=$ac_optarg ;;
857    
858          -tdir | --tdir | -t | --t)          -tdir | --tdir | -t | --t)
859              ac_prev=TESTDIRS ;;              ac_prev=TESTDIRS ;;
860          -tdir=* | --tdir=*)          -tdir=* | --tdir=*)
861              TESTDIRS=$ac_optarg ;;              TESTDIRS=$ac_optarg ;;
862    
863            -skipdir | --skipdir | -skd | --skd)
864                ac_prev=SKIPDIRS ;;
865            -skipdir=* | --skipdir=*)
866                SKIPDIRS=$ac_optarg ;;
867    
868          -bash | --bash | -b | --b)          -bash | --bash | -b | --b)
869              ac_prev=BASH ;;              ac_prev=BASH ;;
870          -bash=* | --bash=*)          -bash=* | --bash=*)
# Line 481  for ac_option ; do Line 880  for ac_option ; do
880          -make=* | --make=*)          -make=* | --make=*)
881              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
882    
883            -odir | --odir)
884                ac_prev=OUTDIR ;;
885            -odir=* | --odir=*)
886                OUTDIR=$ac_optarg ;;
887    
888            -ptracers | --ptracers | -ptr | --ptr)
889                ac_prev=PTRACERS_NUM ;;
890            -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)
891                PTRACERS_NUM=$ac_optarg ;;
892    
893            -match | --match ) ac_prev=MATCH_CRIT ;;
894            -match=* | --match=* ) MATCH_CRIT=$ac_optarg ;;
895    
896            -j) ac_prev=JOBS ;;
897            -j=*) JOBS=$ac_optarg ;;
898    
899          -clean | --clean)          -clean | --clean)
900              CLEANUP=t ;;              CLEANUP=t ; DELDIR=t ;;
901    
902          -quick | --quick | -q | --q)          -quick | --quick | -q | --q)
903              QUICK=t ;;              QUICK=t ;;
# Line 493  for ac_option ; do Line 908  for ac_option ; do
908          -nodepend | --nodepend | -nd | --nd)          -nodepend | --nodepend | -nd | --nd)
909              NODEPEND=t ;;              NODEPEND=t ;;
910    
911            -postclean | --postclean | -pc | --pc)
912                POSTCLEAN=t ;;
913    
914          -mpi) MPI=t ;;          -mpi) MPI=t ;;
915    
916            -mth) MULTI_THREAD=t ;;
917    
918            -adm | -ad) ADM=t ;;
919    
920            -oad) OADM=t; NODEPEND=t ;;
921    
922            -ieee) IEEE=true ;;
923            -noieee) IEEE= ;;
924            -gsl) GSL=t ;;
925    
926          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
927          -debug) debug=1 ;;          -debug) debug=1 ;;
         -clean) clean=1 ;;  
928          -quiet) verbose=0 ;;          -quiet) verbose=0 ;;
929    
930            -deldir | -dd) DELDIR=t ;;
931    
932            -ts) TS=t;;
933    
934            -papis) PAPIS=t;;
935    
936            -pcls) PCL=t;;
937    
938          -*)          -*)
939              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
940              usage              usage
# Line 519  if test "x$QUICK" = xt ; then Line 955  if test "x$QUICK" = xt ; then
955      NODEPEND=t      NODEPEND=t
956  fi  fi
957    
958    #- setting for forward or ADM testing
959    if test "x$ADM" = xt ; then
960        code_dir=code_ad
961        inputdir=input_ad
962        ref_outp="output_adm.txt"
963        EXECUTABLE="mitgcmuv_ad"
964    elif test "x$OADM" = xt ; then
965        code_dir=code_oad
966        inputdir=input_oad
967        ref_outp="output_oadm.txt"
968        EXECUTABLE="mitgcmuv_ad"
969    else
970        code_dir=code
971        inputdir=input
972        ref_outp="output.txt"
973        EXECUTABLE="mitgcmuv"
974    fi
975    
976  if test "x$TESTDIRS" = x ; then  if test "x$TESTDIRS" = x ; then
977      TESTDIRS=`scandirs`      LIST=`scandirs results/$ref_outp`
978    else
979        #- expand group of experiments:
980        LIST=" "
981        for xx in $TESTDIRS
982        do
983          case $xx in
984            'basic') LIST=${LIST}" aim.5l_cs hs94.128x64x5 ideal_2D_oce"
985                     LIST=${LIST}" lab_sea tutorial_baroclinic_gyre"
986                     LIST=${LIST}" tutorial_global_oce_latlon tutorial_plume_on_slope"
987                    ;;
988            'tutorials')
989                     LIST=${LIST}" "`ls | grep 'tutorial_'` ;;
990            *)       LIST=${LIST}" "$xx ;;
991          esac
992        done
993  fi  fi
994    #echo 'LIST='${LIST}'<'
995    #- skip dirs, remove duplicate and non-directory:
996    TESTDIRS=" "
997    count=0
998    for xx in $LIST
999    do
1000        yy=`echo $SKIPDIRS | grep -c $xx`
1001        if test $yy = 0 ; then
1002            if test -d $xx ; then
1003                yy=`echo $TESTDIRS | grep -c $xx`
1004                if test $yy = 0 ; then TESTDIRS=${TESTDIRS}" "$xx ; fi
1005            else count=1 ;
1006                echo ""; echo -n " -- skip \"$xx\" (not a directory !)"
1007            fi
1008        else
1009            if test $count = 1 ; then echo -n ", \"$xx\""
1010            else count=1 ; echo "" ;  echo -n " skip: \"$xx\""
1011            fi
1012        fi
1013    done
1014    if test $count = 1 ; then echo "" ; echo -n " ... " ; fi
1015    #echo 'TESTDIRS='${TESTDIRS}'<'
1016    
1017  if test "x$OPTFILES" = x ; then  if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then
1018      OPTFILES=$MITGCM_OF      OPTFILE=$MITGCM_OF
1019  fi  fi
1020  if test "x$OPTFILES" = x ; then  
1021      echo "Error: please specify an optfile using either the command-line or"  RUNLOG="run.log"
1022      echo "  the MITGCM_OF environment variable.  Also, examples are located "  OUTPUTFILE=$ref_outp
1023      echo "  in \$ROOTDIR/tools/build_options"  if test "x$COMMAND" = x ; then
1024      exit 1      COMMAND="./$EXECUTABLE > $OUTPUTFILE"
1025  fi  fi
1026    if test "x$MPI" = xt ; then
1027        OUTPUTFILE="STDOUT.0000"
1028    fi
1029    
1030    echo "OK (COMMAND= $COMMAND )"
1031    
1032  echo "OK"  # set the Default List of output variables to be checked:
1033    #  (use default or load experiment-specific list from file "tr_checklist")
1034    # content : 1rst = main variable used to decide if it pass or FAIL
1035    #         others = number of matching digits to be printed in summary.txt
1036    if test "x$ADM" = x -a "x$OADM" = x; then
1037        DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
1038        EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
1039        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1040        ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
1041        EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
1042    else
1043        DEF_CHECK_LIST='Grad Cost Grad'
1044        EMPTY_RESULTS='.. ..'
1045        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1046    fi
1047    
1048  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
1049  createcodelet  createcodelet
1050    
1051  #  build the mpack utility  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
1052  build_mpack  if test "x$ADDRESSES" = x ; then
1053        echo "skipping mpack build"
1054    else
1055        build_mpack
1056    fi
1057    
1058  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
1059    CMDLINE=$0
1060    for xx in "$@" ; do nw=`echo $xx | wc -w`
1061        if test $nw = '1' ; then CMDLINE="$CMDLINE $xx"
1062                            else CMDLINE="$CMDLINE '$xx'" ; fi
1063    done
1064    #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
1065  MACH=`hostname`  MACH=`hostname`
1066  UNAMEA=`uname -a`  UNAMEA=`uname -a`
1067  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
1068  BASE=$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
1069    if test "x$OUTDIR" != x ; then
1070        BASE="tr_"$OUTDIR"_"$DATE"_"
1071    else
1072        short_name=`hostname | sed 's/\..*$//'`
1073        BASE="tr_"$short_name"_"$DATE"_"
1074    fi
1075  DNUM=0  DNUM=0
1076  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
1077  while test -e $DRESULTS ; do  while test -e $DRESULTS ; do
# Line 555  done Line 1081  done
1081  mkdir $DRESULTS  mkdir $DRESULTS
1082  RETVAL=$?  RETVAL=$?
1083  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
1084      echo "Error: can't create results directory \"./$DRESULTS\""      echo "ERROR: Can't create results directory \"./$DRESULTS\""
1085      exit 1      exit 1
1086  fi  fi
1087  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
1088  date > $SUMMARY  start_date=`date`
1089  cat << EOF >> $SUMMARY  echo $start_date > $SUMMARY
1090                  T           S           U           V  echo 'run:' $CMDLINE >> $SUMMARY
1091  G D M    c        m  s        m  s        m  s        m  s  echo 'on :' $UNAMEA  >> $SUMMARY
1092  E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .  
1093  N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d  of_path=
1094  2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .  if test "x$OPTFILE" != xNONE ; then
1095        if test -r $OPTFILE ; then
1096  EOF          # get the path
1097            path=${OPTFILE%/*}
1098  NDIR=0          if test "x$path" = x ; then
1099                of_path=`pwd`
1100  #  For each optfile...          else
1101  for OPTFILE in $OPTFILES ; do              of_path=`( cd $path > /dev/null 2>&1 ; pwd )`
1102            fi
1103      OPTFILE=`pwd`"/$OPTFILE"          file=${OPTFILE##*/}
1104      if test ! -r $OPTFILE ; then          OPTFILE=$of_path/$file
1105          echo "Error: can't read optfile \"$OPTFILE\""          cp $OPTFILE $DRESULTS
1106            echo >> $SUMMARY
1107            echo "  OPTFILE=$OPTFILE" >> $SUMMARY
1108        else
1109            echo | tee $SUMMARY
1110            echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee $SUMMARY
1111          exit 1          exit 1
1112      fi      fi
1113      echo  else
1114      echo "OPTFILE=$OPTFILE" >> $SUMMARY      echo >> $SUMMARY
1115        echo "No \"OPTFILE\" was explicitly specified by testreport," >> $SUMMARY
1116        echo "   so the genmake default will be used." >> $SUMMARY
1117    fi
1118    echo
1119    echo >> $SUMMARY
1120    if test "x$ADM" = x -a "x$OADM" = x; then
1121        if [ $MATCH_CRIT -lt 10 ] ;
1122        then line_0="default  "$MATCH_CRIT ;
1123        else line_0="default "$MATCH_CRIT ; fi
1124           line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"
1125    #   line_0="            ----T-----  ----S-----  ----U-----  ----V-----"
1126        line_1="G D M    c        m  s        m  s        m  s        m  s"
1127        line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."
1128        line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
1129        line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."
1130        for ii in $PTRACERS_NUM ; do
1131            line_0="$line_0  --PTR 0"$ii"--"
1132            line_1="$line_1        m  s"
1133            line_2="$line_2  m  m  e  ."
1134            line_3="$line_3  i  a  a  d"
1135            line_4="$line_4  n  x  n  ."
1136        done
1137        echo "$line_0" | tee -a $SUMMARY
1138        echo "$line_1" | tee -a $SUMMARY
1139        echo "$line_2" | tee -a $SUMMARY
1140        echo "$line_3" | tee -a $SUMMARY
1141        echo "$line_4" | tee -a $SUMMARY
1142        echo " "       | tee -a $SUMMARY
1143    else
1144        echo "ADJOINT=true" >> $SUMMARY
1145      echo >> $SUMMARY      echo >> $SUMMARY
1146        if [ $MATCH_CRIT -lt 10 ] ;
1147        then line_0="default     "$MATCH_CRIT ;
1148        else line_0="default    "$MATCH_CRIT ; fi
1149        echo "$line_0" | tee -a $SUMMARY
1150        cat << EOF | tee -a $SUMMARY
1151    G D M    C  G
1152    E p a R  o  r
1153    N n k u  s  a
1154    2 d e n  t  d
1155    
1156    EOF
1157    fi
1158    
1159    #  ...and each test directory...
1160    for dir in $TESTDIRS ; do
1161            
1162      #  ...and each test directory...      # set builddir & rundir:
1163      for dir in $TESTDIRS ; do      builddir="build"
1164        if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1165        rundir="run"
1166        if test ! -d $dir/$rundir ; then
1167            rundir=$builddir
1168        fi
1169        CODE_DIR=$dir/$code_dir
1170        BUILD_DIR=$dir/$builddir
1171    
1172          #  Cleanup only!      #  Cleanup only!
1173          if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1174              if test -r $dir/build/Makefile ; then          echo -n '  --- dir:' $BUILD_DIR ': '
1175                  ( cd $dir/build ; make CLEAN )          makeclean $BUILD_DIR
1176              fi          rm -f $BUILD_DIR/$EXECUTABLE
1177              if test -r $dir/input/Makefile ; then          if test -d $dir/$rundir/CVS ; then
1178                  ( cd $dir/input ; make CLEAN )              echo -n '  --- dir:' $dir/$rundir ': '
1179              fi              run_clean $dir/$rundir
             continue  
1180          fi          fi
1181            trdir=`( cd $dir ; find . -type d -name "tr_run.*" -print | sed 's/^.\///')`
1182          #  Verify that the testdir exists and contains previous          ttd=`echo $trdir | wc -w`
1183          #  results in the correct location--or skip this directory!          if test $ttd != 0 ; then
1184          if test ! -r $dir"/results/output.txt" ; then              echo '  --- rm dir:' $trdir
1185              echo              ( cd $dir ; rm -rf $trdir )
             echo "can't read \"$dir/results/output.txt\" -- skipping $dir"  
             echo  
             continue  
1186          fi          fi
1187            continue
1188        fi
1189    
1190          echo "-------------------------------------------------------------------------------"      #  Verify that the testdir exists and contains previous
1191          echo      #  results in the correct location--or skip this directory!
1192          echo "Experiment:  $dir"      fout=$dir"/results/"$ref_outp
1193          echo      if test ! -r $fout ; then
1194          unset genmake makedepend make run          echo "can't read \"$fout\" -- skipping $dir"
1195          results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'          continue
1196        fi
         if [ -r $dir/build ]; then  
             seperatebuilddir=1  
             builddir=build  
             rundir=build  
             ( cd $dir/build; ln -sf ../input/* . )  
         else  
             seperatebuilddir=0  
             builddir=input  
             rundir=input  
         fi  
1197    
1198          CODE_DIR=$dir/code      # Check for specific files for particular type of run
         BUILD_DIR=$dir/$builddir  
         MPI_FILES="CPP_EEOPTIONS.h_mpi SIZE.h_mpi"  
         NOMPI_FILES="CPP_EEOPTIONS.h_nompi SIZE.h_nompi"  
         #  Is this an MPI run?  
         if test "x$MPI" = xt ; then  
             FILES=$MPI_FILES  
         else  
             FILES=$NOMPI_FILES  
         fi  
1199    
1200          #  Check to see that we have the files      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
1201          have_files=t          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
1202          for i in $FILES ; do          continue
1203              if test ! -r $CODE_DIR/$i ; then      fi
1204                  echo "Warning: can't read file $CODE_DIR/$i" | tee -a $SUMMARY      if test ! -r $dir"/input/eedata.mth" -a "x$MULTI_THREAD" = "xt" ; then
1205                  have_files=f          echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"
1206              fi          continue
1207          done      fi
1208          if test "x$have_files" != xt -a "x$MPI" = xt ; then      if test "x$MPI" = "xt" -a "x$MULTI_THREAD" = "xt" ; then
1209              echo "Skipping $dir due to lack of input files (see above warning)" \        retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/input/eedata.mth"`
1210                  | tee -a $SUMMARY        if test $retv != 0 ; then
1211              continue          echo "input/eedata.mth tiling misfit -- skipping $dir"
1212          fi          continue
1213          fi
1214        fi
1215    
1216          #  If we have the $FILES and they differ, copy the $FILES to $BUILD_DIR      #  Check whether there are "extra runs" for this testdir
1217          if "x$have_files" = xt ; then      extra_runs=
1218              for i in $FILES ; do      ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1219                  cmp $CODE_DIR/$i $BUILD_DIR/$i > /dev/null 2>&1      #echo "ex_run_dirs='$ex_run_dirs'"
1220                  RETVAL=$?      for exd in $ex_run_dirs ; do
1221                  if test "x$RETVAL" != x0 ; then          name=`echo $exd | sed -e "s/$inputdir\.//"`
1222                      cp $CODE_DIR/$i $BUILD_DIR/$i          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1223            outf="$dir/results/$refExOut"
1224            if test -f $outf -a -r $outf ; then
1225              if test "x$MULTI_THREAD" = "xt" ; then
1226                if test -r $dir"/"$exd"/eedata.mth" ; then
1227                  if test "x$MPI" = "xt" ; then
1228                    retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/"$exd"/eedata.mth"`
1229                    if test $retv = 0 ; then
1230                        extra_runs="$extra_runs $name"
1231                    else
1232                        echo $exd"/eedata.mth tiling misfit -- skipping $dir"
1233                  fi                  fi
1234              done                else
1235                    extra_runs="$extra_runs $name"
1236                  fi
1237                #else echo $dir"/"$exd"/eedata.mth: not found"
1238                fi
1239              else
1240                extra_runs="$extra_runs $name"
1241              fi
1242          fi          fi
1243        done
1244    
1245          #  Create an output dir for each OPTFILE/tdir combination      echo "-------------------------------------------------------------------------------"
1246          CDIR=$DRESULTS"/"$DRESULTS"_"$NDIR      echo
1247          mkdir $CDIR      if test "x$extra_runs" = "x" ; then
1248          CDIR=`pwd`"/$CDIR"         echo "Experiment:  $dir"
1249        else
1250          if test "x$CLEANUP" = xt ; then         echo "Experiment:  $dir ; extra_runs=$extra_runs"
1251              makeclean $dir/$builddir      fi
1252          else      echo
1253              genmakemodel $dir/$builddir && genmake=Y \      unset genmake makedepend make run
1254                  && makeclean $dir/$builddir \      results=$EMPTY_RESULTS
                 && makedependmodel $dir/$builddir && makedepend=Y \  
                 && makemodel $dir/$builddir && make=Y \  
                 && linkdata $seperatebuilddir $dir/$rundir \  
                 && runmodel $dir/$builddir && run=Y \  
                 && results=`testoutput $dir $rundir`  
         fi  
1255    
1256        #  Create an output dir for each OPTFILE/tdir combination
1257        rel_CDIR=$DRESULTS"/"$dir
1258        mkdir $rel_CDIR
1259        CDIR=`pwd`"/$rel_CDIR"
1260        
1261        if test "x$CLEANUP" = xt ; then
1262            echo '====>>> this is to check that we never go through this part <<< ==='
1263            makeclean $dir/$builddir \
1264                && run_clean $dir/$rundir
1265        else
1266            genmakemodel $dir/$builddir && genmake=Y \
1267                && makeclean $dir/$builddir \
1268                && run_clean $dir/$rundir \
1269                && symlink_mpifiles $dir $code_dir $builddir \
1270                && makedependmodel $dir/$builddir && makedepend=Y \
1271                && makemodel $dir/$builddir && make=Y \
1272                && linkdata $dir/$rundir $inputdir input \
1273                && runmodel $dir/$rundir && run=Y \
1274                && results=`testoutput_run $dir $rundir $ref_outp`
1275        fi
1276        
1277        echo
1278            fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1279          echo          echo
1280          formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1281              ${run:-N} $results          touch $CDIR"/summary.txt"
1282          echo          echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
         formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \  
             ${run:-N} $results >> $SUMMARY  
         echo "fresults='" > $CDIR"/summary.txt"  
         formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \  
             ${run:-N} $results >> $CDIR"/summary.txt"  
         echo "'" >> $CDIR"/summary.txt"  
1283          echo "MACH='$MACH'" >> $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1284          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1285          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1286          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1287            if test "x$ADM" = xt ; then
1288                head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1289                grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1290                                    >> $CDIR"/summary.txt"
1291            fi
1292    
1293          (          for ex in $extra_runs ; do
1294              cd $DRESULTS              unset run
1295              tar -cf $NDIR".tar" $DRESULTS"_"$NDIR > /dev/null 2>&1              results=$EMPTY_RESULTS
1296              gzip $NDIR".tar"              #  reference output file
1297          )              refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1298                #  Create an output dir for each OPTFILE/tdir.ex combination
1299                rel_CDIR=$DRESULTS"/"$dir"."$ex
1300                mkdir $rel_CDIR
1301                CDIR=`pwd`"/$rel_CDIR"
1302                test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1303                run_clean $dir/tr_run.$ex
1304                linkdata $dir/tr_run.$ex $inputdir.$ex $inputdir input
1305                runmodel $dir/tr_run.$ex && run=Y \
1306                && results=`testoutput_run $dir tr_run.$ex $refExOut`
1307                fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1308                fres="$fres.$ex"
1309                echo
1310                echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1311                touch $CDIR"/summary.txt"
1312                echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1313                echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1314                echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1315                echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1316                echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1317                if test "x$ADM" = xt ; then
1318                    head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1319                    grep -A3 'Seconds in section "ALL' $dir/tr_run.$ex/$OUTPUTFILE \
1320                                       >> $CDIR"/summary.txt"
1321                fi
1322                if test "x$POSTCLEAN" = xt ; then
1323                    run_clean $dir/tr_run.$ex
1324                fi
1325            done
1326    
1327          if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then      #postclean $dir/$builddir
1328              echo "No mail sent"      if test "x$POSTCLEAN" = xt ; then
1329            makeclean $dir/$builddir \
1330                && run_clean $dir/$rundir
1331        fi
1332        
1333        echo "-------------------------------------------------------------------------------"
1334        
1335    done
1336    
1337    printf "Start time:  " >> $SUMMARY
1338    echo "$start_date" >> $SUMMARY
1339    printf "End time:    " >> $SUMMARY
1340    date >> $SUMMARY
1341    
1342    #  If addresses were supplied and mpack built successfully, then try
1343    #  to send email using mpack.
1344    if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
1345        echo "No results email was sent."
1346    else
1347        if test "x$HAVE_MPACK" = xt ; then
1348            tar -cf $DRESULTS".tar" $DRESULTS > /dev/null 2>&1 \
1349                && gzip $DRESULTS".tar" \
1350                && $MPACK -s MITgcm-test -m 3555000 $DRESULTS".tar.gz" $ADDRESSES
1351            RETVAL=$?
1352            if test "x$RETVAL" != x0 ; then
1353                echo
1354                echo "Warning: The tar, gzip, & mpack step failed.  Please send email"
1355                echo "  to <MITgcm-support@mitgcm.org> for help.  You may copy the "
1356                echo "  summary of results from the directory \"$DRESULTS\"."
1357                echo
1358          else          else
1359              $MPACK -s MITgcm-test -m 1000000 $DRESULTS"/"$NDIR".tar.gz" $ADDRESSES              echo
1360              RETVAL=$?              echo "An email containing results was sent to the following addresses:"
1361              if test "x$RETVAL" != x0 ; then              echo "  \"$ADDRESSES\""
1362                  echo "Warning: \"$MPACK\" failed -- please contact <edhill@mitgcm.org>"              echo
1363              else              test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"
1364                  rm -f $DRESULTS"/"$NDIR".tar*"              test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"
             fi  
1365          fi          fi
1366        fi
1367    fi
1368    
1369          NDIR=$(( $NDIR + 1 ))  rm -f tr_cmpnum.c tr_cmpnum
           
     done  
 done  
1370    
1371  rm tmp_cmpnum.f a.out  if test "x$CLEANUP" != xt ; then
1372        cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'
1373        if test -e tr_out.txt ; then
1374            mv tr_out.txt tr_out.txt.old
1375        fi
1376        cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt
1377    fi
1378    
1379  cat $SUMMARY  if test "x$DELDIR" = xt ; then
1380        rm -rf $DRESULTS
1381    fi
1382    

Legend:
Removed from v.1.9.2.5  
changed lines
  Added in v.1.131

  ViewVC Help
Powered by ViewVC 1.1.22